        PAGE    60,132
name    NEED
        TITLE   HHMM 1.3

Comment 

HHMM.com Displays DOS time in form HH:MM without a CrLf
uses 24 hour time


Please report bugs and problems to:

Roedy Green
Canadian Mind Products
#208 - 525 Ninth Street
New Westminster BC Canada
V5H 2N6
tel:(604) 777-1804
mailto:roedy@mindprod.com
http://mindprod.com


Version 1.3 1998 November 8
- embed Barker address

Version 1.2 1996 October 25
- embed POB 707 Quathiaski Cove address

Version 1.1 1993 June 11
- address change

Version 1.0 1991 Dec 20
- released on BIX


;==============================================================

;       R E G I S T E R   C O N V E N T I O N S

Subroutines may trash any registers they please except CS: DS:
ES: SS: and of course the outputs.

 ; end of comment

;==============================================================

stack   segment stack           ; keep MS link happy by providing null stack
stack   ends

;==============================================================

CODE    SEGMENT PARA            ; start off in code.

;==============================================================

data    segment word            ; provide a separate DATA segment
                                ; Even though it appears in the source
                                ; before the code, it the COM file it
                                ; will appear at the end.  This is as dodge
                                ; to avoid forward references that confuse
                                ; MASM.

Colon   DB ':','$'              ; separator we use on time

;       embedded but not displayed

CopyrightMsg    label byte
        db      13,10
        DB      ' HHMM 1.3 ۲',13,10
        DB      'Copyright (c) 1991-1999 Roedy Green Canadian Mind Products',13,10
        DB      '#208 - 525 Ninth Street, New Westminster, BC Canada V3M 5T9',13,10
        DB      'tel:(604) 777-1804   mailto:roedy@mindprod.com   http://mindprod.com',13,10
        DB      'May be freely distributed and used for any purpose except military.',13,10
        db      '$'

Data    EndS

;==============================================================

com     group   code,data       ; force data segment to go at the end

        ASSUME  CS:com,DS:com,ES:com,SS:com
                                ; seg regs cover everything
        ORG     100H            ; in Code segment



;==============================================================

;       P R O C E D U R E S

Main    Proc    near


;       see page 386 Ray Duncan's Advanced MS DOS

        mov     ah,02ch                 ; get date TIME function
        int     21h
                                        ; CH = hours
                                        ; CL = minutes
                                        ; DH = seconds
                                        ; DL = deciseconds

        mov     bx,cx                   ; save copy of hours:min
        sub     ax,ax
        mov     al,bh                   ; display hours
        mov     cx,2                    ; 2 digits
        call    SayNDigits

        Call    SayColon                ; separate HH:MM

        sub     ax,ax                   ; display minutes, 2 digits
        mov     al,bl
        mov     cx,2
        call    SayNDigits


        mov     ax, 4c00h               ; ERRORLEVEL = 0
        int     21h                     ; normal exit to dos

Main    EndP

;==============================================================


SayColon        Proc    Near

;       displays / on screen using BIOS
        push    dx
        lea     dx,Colon
        mov     AH,09h
        int     21h
        pop     dx
        ret

SayColon        EndP

;==============================================================

SayNDigits PROC    NEAR

;       call with unsigned number in AX, CX counts how many digits you want
;       converts it to ASCII and displays it on the screen
;       leading 0's are NOT suppressed.
;       Field is exactly wide enough to hold the number.
;       No leading or trailing spaces.  DISPLAYED IN DECIMAL
;
;       Method is to repeatedly divide by 10.  The remainder at
;       each stage is one digit of the result, working right to left.
;       Preserves all registers

Data    Segment

PAD     DB      15 dup (0)      ; where build the output string
PADend  db      '$'             ; terminator for Say

Data    EndS

        push    ax
        push    bx
        push    cx
        push    dx
        push    di              ; preserve di
        mov     bx,10d
        lea     di,padEnd       ; point at $ trailing the PAD
                                ; work right to left building digits at PAD
                                ; CX counts number of digits
NumLoop:                        ; loop once for each digit
                                ; number so far is in dx:ax
        mov     bx,10
        sub     dx,dx           ; clear out high order part of DX:AX
        div     bx              ; dx=remdr ax=quot

        add     dl,'0'          ; convert digit to ASCII

        dec     di              ; work right to left
        mov     [di],dl         ; save digit

        loop    NumLoop

        mov     dx,di           ; start of ascii string, terminated by $
        mov     AH,09h          ; BIOS put string terminated by $
        int     21h
        pop     di              ; restore caller's registers
        pop     dx
        pop     cx
        pop     bx
        pop     ax
        ret

SayNDigits  endp


;============================================

CODE    ends                    ; end of code segment

        end     Main
